SystemOrganization addCategory: #'Pier-Security-Model'!
SystemOrganization addCategory: #'Pier-Security-Command'!
SystemOrganization addCategory: #'Pier-Security-Tests'!

PRCommand subclass: #PUChangeSecurity
	instanceVariableNames: 'with all hidden operator permissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

PUChangeSecurity subclass: #PUChangeGroup
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeGroup class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionGroup
	^ (MASingleOptionDescription selector: #group label: 'Group' priority: 200)
		comment: 'Changes the group ownership to the selected group.';
		options: (MADynamicObject on: [ self groupInstances ]);
		reference: PUGroup description;
		undefined: '(unchanged)';
		beSorted;
		yourself! !

!PUChangeGroup class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeGroup class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
label
	^ 'Change Group'! !

!PUChangeGroup methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration groupCommands )! !

!PUChangeGroup methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doExecuteFor: aStructure
	self group notNil
		ifTrue: [ aStructure securityDecoration group: self group ].
	super doExecuteFor: aStructure! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
group
	^ group ifNil: [ group := self structure group ]! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
group: aGroup
	group := aGroup! !

PUChangeSecurity subclass: #PUChangeOther
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOther class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOther class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
label
	^ 'Change Other'! !

!PUChangeOther methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration otherCommands )! !

PUChangeSecurity subclass: #PUChangeOwner
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOwner class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionOwner
	^ (MASingleOptionDescription selector: #owner label: 'Owner' priority: 200)
		comment: 'Changes the ownership to the selected user.';
		options: (MADynamicObject on: [ self userInstances ]);
		reference: PUUser description;
		undefined: '(unchanged)';
		beSorted;
		yourself! !

!PUChangeOwner class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOwner class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
label
	^ 'Change Owner'! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration ownerCommands )! !

!PUChangeOwner methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doExecuteFor: aStructure
	self owner notNil
		ifTrue: [ aStructure securityDecoration owner: self owner ].
	super doExecuteFor: aStructure! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
owner
	^ owner ifNil: [ owner := self structure owner ]! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
owner: anUser
	owner := anUser! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
commandClasses
	^ PRCommand withAllConcreteClasses asSet
		remove: PULogin;
		remove: PULogout;
		yourself! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:31'!
defaultAll
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:31'!
defaultHidden
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:31'!
defaultOperator
	^ self defaultOperators first! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:31'!
defaultOperators
	^ #( set add remove )! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:31'!
defaultWith
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionAll
	^ (MABooleanDescription selector: #all label: 'Recursive' priority: 110 default: self defaultAll)
		comment: 'Apply changes recursively to all children.';
		beRequired;
		yourself! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionHidden
	^ (MABooleanDescription selector: #hidden label: 'Hidden' priority: 120 default: self defaultHidden)
		comment: 'Apply changes to hidden structures.';
		beRequired;
		yourself! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionOperator
	^ (MASingleOptionDescription selector: #operator label: 'Operator' priority: 300 default: self defaultOperator)
		comment: 'Defines if the permissions should remain unchanged, be set to the selected ones, or be added/removed from the current selection.';
		reference: MASymbolDescription new;
		options: self defaultOperators;
		undefined: '(unchanged)';
		yourself! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionPermissions
	^ (MAMultipleOptionDescription selector: #permissions label: 'Permissions' priority: 310)
		comment: 'Defines the set of permissions used together with the selected operation.';
		options: (MADynamicObject on: [ self commandClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionWith
	^ (MABooleanDescription selector: #with label: 'Current' priority: 100 default: self defaultWith)
		comment: 'Apply changes to the current structure.';
		beRequired;
		yourself! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
groupInstances
	^ PRCurrentContext value kernel groups! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
userInstances
	^ PRCurrentContext value kernel users! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
accessor
	self subclassResponsibility! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
all
	^ all ifNil: [ all := self class defaultAll ]! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
all: aBoolean
	all := aBoolean! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doExecute
	super doExecute.
	self structure enumerator
		with: self with; all: self all; hidden: self hidden;
		do: [ :each | self doExecuteFor: each ]! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doExecuteFor: aStructure
	"Apply the changes to aStructure. Override this method to further modify aStructure. This method is automatically called by #doExecute for all the requested structure."

	self accessor
		write: (self operator = #set
			ifTrue: [ self permissions copy ]
			ifFalse: [
				self operator = #add
					ifTrue: [
						(self accessor read: aStructure)
							copyWithAll: self permissions ]
					ifFalse: [
						self operator = #remove
							ifTrue: [
								(self accessor read: aStructure)
									copyWithoutAll: self permissions ]
							ifFalse: [ ^ self ] ] ])
		to: aStructure! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
hidden
	^ hidden ifNil: [ hidden := self class defaultHidden ]! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
hidden: aBoolean
	hidden := aBoolean! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 3/9/2006 11:30'!
operator
	^ operator! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 3/9/2006 11:30'!
operator: aSymbol
	operator := aSymbol! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 3/9/2006 11:30'!
permissions
	^ permissions ifNil: [ permissions := self accessor read: self structure ]! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 3/9/2006 11:30'!
permissions: aCollectionOfCommands
	permissions := aCollectionOfCommands asSet! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
with
	^ with ifNil: [ with := self class defaultWith ]! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 3/9/2006 11:30'!
with: aBoolean
	with := aBoolean! !

PRCommand subclass: #PULogin
	instanceVariableNames: 'username password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionPassword
	^ (MAPasswordDescription selector: #password label: 'Password' priority: 200)
		beRequired;
		yourself! !

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionUsername
	^ (MAStringDescription selector: #username label: 'Username' priority: 100)
		beRequired;
		yourself! !

!PULogin class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULogin class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isValidIn: aContext
	^ aContext isLoggedIn not! !

!PULogin class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
label
	^ 'Login'! !

!PULogin methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doAnswer
	super doAnswer.
	self answer: (self answer user: self user)! !

!PULogin methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
doValidate
	super doValidate.
	self user: (self kernel users
		detect: [ :each |
			each name = self username
				and: [ each validatePassword: self password ] ]
		ifNone: [ PUInvalidLogin signal: 'Invalid username or password.' ])! !

!PULogin methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isLogged
	^ false! !

!PULogin methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
password
	^ password ifNil: [ password := String new ]! !

!PULogin methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
password: aString
	password := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
user
	^ user! !

!PULogin methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
username
	^ username ifNil: [ username := String new ]! !

!PULogin methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
username: aString
	username := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
user: aUser
	user := aUser! !

PRCommand subclass: #PULogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogout class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULogout class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isValidIn: aContext
	^ aContext isLoggedIn! !

!PULogout class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
label
	^ 'Logout'! !

!PULogout methodsFor: 'events' stamp: 'lr 3/21/2006 18:08'!
doAnswer
	super doAnswer.
	self answer: (self answer user: nil)! !

!PULogout methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isLogged
	^ false! !

!PULogout methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isQuick
	^ true! !

PRDecoration subclass: #PUSecurity
	instanceVariableNames: 'owner ownerCommands group groupCommands otherCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUSecurity commentStamp: 'lr 12/20/2005 15:05' prior: 0!
Every structure is owned by a specific user. The owner of an object comprises its user class. Permissions assigned to the user class only apply to that specific user. A structure is also assigned a group, which comprises its group class. Permissions assigned to the group class only apply to members of that group. Users who are not otherwise represented by the other two classes comprise a file's others class.

The effective permissions that have applied to a specific user in relation to a file are determined in logical precedence. For example, the user who owns the file will have the effective permissions given to the user class regardless of those assigned to the group or others class.!

!PUSecurity class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUSecurity class methodsFor: 'events' stamp: 'lr 3/9/2006 11:31'!
onStructureAdded: aStructure
	| decoration |
	decoration := aStructure isRoot
		ifTrue: [ aStructure securityDecorationClass new ]
		ifFalse: [ aStructure parent securityDecoration copy ].
	PRCurrentContext value ifNotNilDo: [ :context |
		decoration
			owner: context user;
			group: (context user
				ifNotNil: [ context user group ]) ].
	^ aStructure
		addDecoration: decoration
		ifPresent: [ :value | value ]! !

!PUSecurity methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:31'!
accept: aVisitor
	aVisitor visitSecurity: self! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
group
	^ group! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
groupCommands
	^ groupCommands ifNil: [ groupCommands := self ownerCommands copy ]! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
groupCommands: aSet
	groupCommands := aSet asSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
group: aGroup
	group := aGroup! !

!PUSecurity methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:31'!
initialize
	super initialize.
	self ownerCommands: PRCommand withAllConcreteClasses asSet.
	self groupCommands: self ownerCommands copy.
	self otherCommands: (Array with: PRViewCommand)! !

!PUSecurity methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAllowedCommand: aCommandClass in: aContext
	(aContext user notNil and: [ aContext user isSuperuser ])
		ifTrue: [ ^ true ].
	(self owner = aContext user)
		ifTrue: [ ^ self ownerCommands includes: aCommandClass ].
	(self group notNil and: [ self group includes: aContext user ])
		ifTrue: [ ^ self groupCommands includes: aCommandClass ].
	^ self otherCommands includes: aCommandClass! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
otherCommands
	^ otherCommands ifNil: [ otherCommands := Set with: PRViewCommand ]! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
otherCommands: aSet
	otherCommands := aSet asSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
owner
	^ owner! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
ownerCommands
	^ ownerCommands ifNil: [ ownerCommands := PRCommand withAllConcreteClasses asSet ]! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 3/9/2006 11:31'!
ownerCommands: aSet
	ownerCommands := aSet asSet! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
owner: anUser
	owner := anUser! !

!PUSecurity methodsFor: 'copying' stamp: 'lr 3/9/2006 11:31'!
postCopy
	super postCopy.
	self ownerCommands: self ownerCommands copy.
	self groupCommands: self groupCommands copy.
	self otherCommands: self otherCommands copy! !

!PUSecurity methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:31'!
priority
	^ -200! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 3/9/2006 11:30'!
descriptionGroup
	^ (MAToOneRelationDescription selector: #group label: 'Group' priority: 120)
		classes: (Array with: PUGroup);
		yourself! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 3/9/2006 11:30'!
descriptionOwner
	^ (MAToOneRelationDescription selector: #owner label: 'Owner' priority: 110)
		classes: (Array with: PUUser);
		yourself! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
group
	"Answer the owning-group of the file."

	^ self securityDecoration ifNotNilDo: [ :value | value group ]! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
owner
	"Answer the owning-user of the receiver."

	^ self securityDecoration ifNotNilDo: [ :value | value owner ]! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 3/9/2006 11:30'!
securityDecoration
	^ self
		decorationOfClass: self securityDecorationClass
		ifAbsent: [ self securityDecorationClass onStructureAdded: self ]! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 3/9/2006 11:30'!
securityDecorationClass
	^ PUSecurity! !

MADistribution subclass: #PUDistribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
package
	"The SqueakMap package name."

	^ 'Pier Unix Security'! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
packages
	^ #( ( 'Pier-Security' ) )! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
preamble
	^ '(SMSqueakMap default packageWithName: ''Pier'')
	lastRelease install.' , String cr! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 3/21/2006 18:18'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( pierunixsecurity 1 0 2 alpha )! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
group
	^ self user group! !

!PRContext methodsFor: '*pier-security-testing' stamp: 'lr 3/9/2006 11:30'!
isLoggedIn
	^ self user notNil! !

!PRContext methodsFor: '*pier-security-initialization' stamp: 'lr 3/9/2006 11:30'!
setUser: aUser
	self propertyAt: #user put: aUser! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
user
	^ self propertyAt: #user ifAbsentPut: [ nil ]! !

!PRContext methodsFor: '*pier-security-navigation' stamp: 'lr 3/9/2006 11:30'!
user: anUser
	"Create a copy of the current context with the current user replaced by anUser."

	^ self copy
		setUser: anUser;
		yourself! !

!PRVisitor methodsFor: '*pier-security-visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitSecurity: anObject
	self visitDecoration: anObject! !

PRObject subclass: #PUMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

PUMember subclass: #PUGroup
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUGroup class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUGroup methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
includes: anUser
	^ self users includes: anUser! !

!PUGroup methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:30'!
initialize
	super initialize.
	users := OrderedCollection new! !

!PUGroup methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:30'!
users
	^ users! !

!PUMember class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:31'!
descriptionName
	^ (MAStringDescription accessor: (MASelectorAccessor read: #name write: #setName:) label: 'Name')
		beReadonly;
		yourself! !

!PUMember class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:31'!
named: aString
	^ self new
		setName: aString;
		yourself! !

!PUMember methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:31'!
hash
	^ self class hash bitXor: self name hash! !

!PUMember methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
name
	^ name! !

!PUMember methodsFor: 'printing' stamp: 'lr 3/9/2006 11:31'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PUMember methodsFor: 'initialize-release' stamp: 'lr 3/9/2006 11:31'!
setName: aString
	name := aString! !

!PUMember methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:31'!
= anObject
	^ self class = anObject class
		and: [ self name = anObject name ]! !

PUMember subclass: #PUUser
	instanceVariableNames: 'password groups superuser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUUser class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUUser methodsFor: 'utilties' stamp: 'lr 3/9/2006 11:31'!
addGroup: aGroup
	self groups add: aGroup.
	aGroup users add: self! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:31'!
group
	^ self groups first! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:31'!
groups
	^ groups! !

!PUUser methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:31'!
initialize
	super initialize.
	groups := OrderedCollection new.
	superuser := false! !

!PUUser methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isSuperuser
	^ self superuser! !

!PUUser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
password
	^ String new: 10 withAll: $*! !

!PUUser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
password: aString
	password := PRCompatibility hashPassword: aString! !

!PUUser methodsFor: 'utilties' stamp: 'lr 3/9/2006 11:31'!
removeGroup: aGroup
	self groups remove: aGroup.
	aGroup users remove: self! !

!PUUser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
superuser
	^ superuser! !

!PUUser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
superuser: aBoolean
	superuser := aBoolean! !

!PUUser methodsFor: 'validating' stamp: 'lr 3/9/2006 11:31'!
validatePassword: aString
	^ aString isEmptyOrNil not
		and: [ (PRCompatibility hashPassword: aString) = password ]! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
adminGroup
	^ self kernel adminGroup! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
adminUser
	^ self kernel adminUser! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
bloggerGroup
	^ self kernel groups
		detect: [ :each | each name = 'blogger' ]
		ifNone: [ self kernel groups add: self bloggerGroupInstance ]! !

!PRCommandTest methodsFor: '*pier-security-private' stamp: 'lr 3/9/2006 11:30'!
bloggerGroupInstance
	^ PUGroup named: 'blogger'! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
bloggerUser
	^ self kernel users
		detect: [ :each | each name = 'james' ]
		ifNone: [ self kernel users add: self bloggerUserInstance ]! !

!PRCommandTest methodsFor: '*pier-security-private' stamp: 'lr 3/9/2006 11:30'!
bloggerUserInstance
	^ (PUUser named: 'james')
		addGroup: self bloggerGroup;
		password: 'bottom';
		yourself! !

PRCommandTest subclass: #PUChangeSecurityTest
	instanceVariableNames: 'child hidden'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

PUChangeSecurityTest subclass: #PUChangeGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeGroupTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeGroupTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeGroup! !

!PUChangeGroupTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
testGroup
	self command
		with: true; all: true; hidden: true;
		group: self bloggerGroup.
	self command execute.

	self assert: self structure group = self bloggerGroup.
	self assert: self hidden group = self bloggerGroup.
	self assert: self child group = self bloggerGroup! !

PUChangeSecurityTest subclass: #PUChangeOtherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeOtherTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOtherTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeOther! !

PUChangeSecurityTest subclass: #PUChangeOwnerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeOwnerTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOwnerTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeOwner! !

!PUChangeOwnerTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
testOwner
	self command
		with: true; all: true; hidden: true;
		owner: self bloggerUser.
	self command execute.

	self assert: self structure owner = self bloggerUser.
	self assert: self hidden owner = self bloggerUser.
	self assert: self child owner = self bloggerUser! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeSecurity! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
child
	^ child ifNil: [ child := self childInstance ]! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
childInstance
	^ PRPage named: 'child'! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
hidden
	^ hidden ifNil: [ hidden := self hiddenInstance ]! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
hiddenInstance
	^ (PRPage named: 'hidden')
		addDecoration: PRHider new;
		yourself! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
permissions
	^ Set with: PRAddCommand with: PRRemoveCommand! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
structureInstance
	^ super structureInstance
		addChild: self child;
		addChild: self hidden;
		yourself! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 3/9/2006 11:30'!
testOperationAdd
	self command
		with: true; all: true; hidden: true;
		operator: #add; permissions: self permissions.
	self command execute.

	self assert: ((self command accessor read: self structure)
		includesAllOf: self permissions).
	self assert: ((self command accessor read: self hidden)
		includesAllOf: self permissions).
	self assert: ((self command accessor read: self child)
		includesAllOf: self permissions)! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 3/9/2006 11:30'!
testOperationRemove
	self command
		with: true; all: true; hidden: true;
		operator: #remove; permissions: self permissions.
	self command execute.

	self deny: ((self command accessor read: self structure)
		includesAnyOf: self permissions).
	self deny: ((self command accessor read: self hidden)
		includesAnyOf: self permissions).
	self deny: ((self command accessor read: self child)
		includesAnyOf: self permissions)! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 3/9/2006 11:30'!
testOperationSet
	self command
		with: true; all: true; hidden: true;
		operator: #set; permissions: self permissions.
	self command execute.

	self assert: (self command accessor read: self structure)
		= self permissions.
	self assert: (self command accessor read: self hidden)
		= self permissions.
	self assert: (self command accessor read: self child)
		= self permissions! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 3/9/2006 11:30'!
testOperationUnchanged
	| structurePermission hiddenPermissions childPermissions |
	structurePermission := (self command accessor read: self structure)
		copy.
	hiddenPermissions := (self command accessor read: self hidden)
		copy.
	childPermissions := (self command accessor read: self child)
		copy.

	self command
		with: true; all: true; hidden: true;
		operator: nil; permissions: self permissions.
	self command execute.

	self assert: (self command accessor
		read: self structure) = structurePermission.
	self assert: (self command accessor
		read: self hidden) = hiddenPermissions.
	self assert: (self command accessor
		read: self child) = childPermissions! !

PRCommandTest subclass: #PULoginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PULoginTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULoginTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PULogin! !

!PULoginTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:30'!
testIsLogged
	self deny: self command isLogged! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:19'!
testLoginAdmin
	self assert: self command context user isNil.
	self command
		username: self adminUser name;
		password: 'pier'.
	self
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self adminUser.
	self assert: self command answer user = self adminUser.
	self assert: self command answer command class = PRViewCommand.
	self assert: self command context user isNil! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:19'!
testLoginBlogger
	self assert: self command context user isNil.
	self command
		username: self bloggerUser name;
		password: 'bottom'.
	self
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self bloggerUser.
	self assert: self command answer user = self bloggerUser.
	self assert: self command answer command class = PRViewCommand.
	self assert: self command context user isNil! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
testLoginInvalidPassword
	self assert: self command context user isNil.
	self command username: self bloggerUser name.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self command context user isNil! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
testLoginInvalidUsername
	self assert: self command context user isNil.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self command context user isNil! !

PRCommandTest subclass: #PULogoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PULogoutTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PULogout! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
contextInstance
	^ super contextInstance user: self bloggerUser! !

!PULogoutTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self deny: self command isLogged! !

!PULogoutTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsQuick
	self assert: self command isQuick! !

!PULogoutTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testingLogout
	self assert: self command context user = self bloggerUser.
	self command execute.
	self assert: self command answer user isNil.
	self assert: self command answer command class = PRViewCommand.
	self assert: self command context user = self bloggerUser! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 3/9/2006 11:30'!
adminGroup
	^ self propertyAt: #adminGroup ifAbsentPut: [ PUGroup named: 'admin' ]! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 3/9/2006 11:30'!
adminUser
	^ self propertyAt: #adminUser ifAbsentPut: [
		(PUUser named: 'admin')
			addGroup: self adminGroup;
			password: 'pier';
			superuser: true;
			yourself ]! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
groups
	^ self propertyAt: #groups ifAbsentPut: [ Set with: self adminGroup ]! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 3/9/2006 11:30'!
users
	^ self propertyAt: #users ifAbsentPut: [ Set with: self adminUser ]! !

MAError subclass: #PUInvalidLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!
